#ifndef HIPC_QUEUE_H
#define HIPC_QUEUE_H

#include <stddef.h>

struct HIPC_queue {
    void *buf_p;
    size_t item_size;
    size_t n_slot;
    volatile size_t head;
    volatile size_t tail;
};

#ifdef __cplusplus
extern "C" {
#endif

    extern void hipcQueueInit(struct HIPC_queue *const que_p,
                              void *const buf_p,
                              const size_t item_size, const size_t n_slot);
    extern size_t hipcQueueItemSize(struct HIPC_queue *const que_p);
    extern void *hipcQueueEmpty(struct HIPC_queue *const que_p);
    extern void hipcQueuePop(struct HIPC_queue *const que_p);
    extern void *hipcQueueFull(struct HIPC_queue const *const que_p);
    extern void hipcQueuePush(struct HIPC_queue *const que_p);
    extern void hipcQueueClear(struct HIPC_queue *const que_p);

#ifdef __cplusplus
}
#endif
#endif
